#!/bin/sh

# cpu throttling
# cat /proc/acpi/processor/CPU0/throttling for more info
ACAD_THR=0
BATT_THR=2

# spindown time for HD (man hdparm for valid values)
# I prefer 2 hours for acad and 20 seconds for batt
ACAD_HD=12
BATT_HD=1

ACAD_DPMS=1200
BATT_DPMS=300

# ac/battery event handler

status=`/bin/awk '/^state: / { print $2 }' /proc/acpi/ac_adapter/AC/state`

case $status in
        "on-line")
                /bin/echo "Setting HD spindown for AC mode."
                /usr/sbin/laptop_mode stop
                /sbin/hdparm -S $ACAD_HD /dev/hda > /dev/null 2>&1
                /sbin/hdparm -B 255 /dev/hda > /dev/null 2>&1
                #echo -n $ACAD_CPU:$ACAD_THR > /proc/acpi/processor/CPU0/limit
		if [ -e /tmp/.X0-lock ]; then
		    /usr/X11R6/bin/xset -display :0 dpms $ACAD_DPMS
		fi
                exit 0
        ;;
        "off-line")
                /bin/echo "Setting HD spindown for battery mode."
                /usr/sbin/laptop_mode start
                /sbin/hdparm -S $BATT_HD /dev/hda > /dev/null 2>&1
                /sbin/hdparm -B 1 /dev/hda > /dev/null 2>&1
                #echo -n $BATT_CPU:$BATT_THR > /proc/acpi/processor/CPU0/limit
		if [ -e /tmp/.X0-lock ]; then
		    /usr/X11R6/bin/xset -display :0 dpms $BATT_DPMS
		fi
                exit 0
        ;;
esac
